/*********************************************************************

CSE/ENGR 142 Homework #4, 98 Autumn
Title:               Rain Gods and Goddesses
Date:                11/9/98

Author:              Patrik Schneider
Student ID:          9823527
E-mail:              schneidp@u.washington.edu

*********************************************************************/

#include "gp142.h"
#include <stdio.h>
#include <math.h>
#include <time.h>

#define TRUE    		1
#define FALSE   		0

/* For the lights on the Space Needle Background. */
# define ON				1
# define OFF			0

/* Configure the appearance of the buttons on the menu bar */
/*number of pixels of button height and width*/
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	110

/*change this if you add or delete buttons*/
#define NUM_BUTTONS 	8

/*color of letter on buttons*/
#define SELECTED_COLOR   PURPLE	 
#define UNSELECTED_COLOW BLACK

/*This is the total number of drops possible at one time.*/
#define MAX_PRECIP_EVENTS	500

/* y-ccordinate of the top of the "dirt" in the landscape*/
#define TOP_OF_DIRT (- 2 * (GP142_YMAX / 5))

/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn. */
#define FILL 0

/* Types of precipitations we support. */
#define NONE 0
#define RAIN 1
#define SNOW 2
#define LIGHTENING 3 

/*Possible places for mouse clicks. */
#define BUTTON 1
	/* The above means you clicked on SOME button. */
#define DIRT 2
	/* The above means you clicked in the dirt area. */

/* Means the user chose a city or the background. */
#define PATRIK_LAND 0
#define SEATTLE		1
#define BACKGROUND	2
	
/*******************  FUNCTION PROTOTYPES **************************/

/* The following are the prototypes for the functions that allow
 * the user to pick different backgrounds. */
void WhichCity (int *place, int *main_quit);
void DrawSeattle (int lights);
void DrawPatrikLand (int sun_x, int sun_y, int cloud_x, int cloud2_x, 
					 int weather);
void DrawFirstButtons(void);
int ClassifyWhichButton(int x, int y);

/* The following are prototypes for the credits. */
void credits(int *main_quit);
void role_credits (int y_position);

/* Redraw all the buttons. The parameters tell which button should be 
 * highlighted. */
void DrawButtons(int current_precip, int current_color, int place);

/* Clear all percipitation, so the landscape is just as originally. */
void ClearAllPrecipitation(int precip_type[], int * i,
						   int * entry_num, int * cloud_x, 
						   int * cloud2_x);

/* Render (draw) all the precipitation. */
void DrawAllPrecipitation(int precip_type[], int x[], int y[], 
						  int color[], int number_of_precip,
						  int place);

void DrawLandscape(int sun_x, int sun_y, int weather, int cloud_x, 
				   int cloud_y, int cloud2_x, int cloud2_y, int place,
				   int lights);

/* Draw one drop. */
void DrawRainDrop (int x, int y, int color);
void DrawSnowDrop (int x, int y, int color);
void LighteningBolt (int x, int y, int color);

/*Return an integer which tells what KIND of click there was. */
int  ClassifyMouseClick(int mouse_x, int mouse_y);

/* Given that a button was click, call an appropriate function to 
 * handle it. */
void handle_button(int x, int y, int *current_precip, 
				   int *current_color, int *replant, 
				   int *new_background);

/*********************************************************************

     MAIN

*********************************************************************/

int main(void)
{
  int quit = FALSE;
  int mouse_x, mouse_y;
  int i = 0, n, entry_num = i;	/* Counters for the arrays.		*/
  int sundown = TRUE;			/* Is the sun going down?		*/
  char key_hit;
  int place;					/* Which city the user want?	*/
  int lights=OFF;				/* To animate the lights.		*/
  int new_background=FALSE;		/* To decide a new background.	*/
  
  int sun_x =GP142_XMAX - 50, sun_y = GP142_YMAX - 35;
  int cloud_x = 0, cloud_y = GP142_YMAX - 55;
  int cloud2_x = 0, cloud2_y = GP142_YMAX - 75; 

  /* The following are arrays that hold: */
  int precip_type[MAX_PRECIP_EVENTS];	/* type of precipitation */
  int precip_color[MAX_PRECIP_EVENTS];	/* color of precipitation */
  int precip_x[MAX_PRECIP_EVENTS];		/* (x,y) coordinates*/
  int precip_y[MAX_PRECIP_EVENTS];
 
  /* What to draw next? */
  int current_precip = NONE, current_color = NONE; 
  
  /* This flag will be true if all weather should be cleared. */
  int clear_flag = FALSE;

  /* What kind of click was there? */
  int mouse_click;

  int event; /* The most recent GP142 event. */

  /* Initializes a random number generator. */
  time_t t; 

  /*
   * INITIALIZATIONS
   */
      
  precip_type [0]	= NONE;

  srand (time(&t));

  GP142_open();          /* Open and init the GP142 Graphics Window */
  GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it. */

  GP142_clear();	/* This will clear the window & paint it white. */
  GP142_animate(ANI_RUN); /* Start animation so precips will fall.  */

  /* The user has started the program, role the credits. */
  credits (&quit);
  
  if (!quit){
	  WhichCity(&place, &quit);
  }

  DrawLandscape(sun_x, sun_y, precip_type[0], cloud_x, cloud_y, 
	  cloud2_x, cloud2_y, place, lights);
  DrawButtons(current_precip, current_color, place);
  ClearAllPrecipitation (precip_type, &i, &entry_num, &cloud_x, 
	  &cloud2_x);


  /*
   * The main event loop:
   * --- ---- ----- -----
   * Repeat this until the user signals "quit".
   */
  while (!quit) {  /* The "event loop". */

	/* Find out what has happened. */
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

	switch (event) {
    case GP142_QUIT:
		quit = TRUE;           /* Set flag to terminate loop. */
		break;

    case GP142_KBD:
		/* Not needed for this program.
		 * Use this if user will need to hit a key.
		 * Note that scanf CANNOT be used with GP142. */
      break;

    case GP142_MOUSE:
	  /* A mouse click has occurred.
       * Check for button versus dirt,
       * handle appropriate button click, if any. */
      mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
	if (mouse_click == BUTTON) {
		/* Updates conditional parameters before handle_button. */
		new_background	= FALSE;

		/* A button has been clicked. Call a function to handle it. */
		handle_button(mouse_x, mouse_y, 
		      &current_precip, &current_color, &clear_flag,
			  &new_background);
 
		if (clear_flag){
			ClearAllPrecipitation(precip_type, &i, &entry_num,
			&cloud_x, &cloud2_x);
			current_precip	= NONE;
			current_color	= NONE;
		}
		
		/* If the background button is pressed change to the other
		 * background. */
		if (new_background == TRUE){

			if (place == SEATTLE){
				place = PATRIK_LAND;
			}else{
				place = SEATTLE;
			}
			
			/* Resets the sun if Patrik Land is chosen. */
			if (place == PATRIK_LAND){
				sun_y = GP142_YMAX - 35;
			}
			
			/* Resets the buttons and the precipitation */
			current_precip = NONE;
			current_color = NONE;
			ClearAllPrecipitation(precip_type, &i, &entry_num,
				&cloud_x, &cloud2_x);
		}
		
	} else if ((mouse_click != DIRT)
		/*it's not a button or in the dirt, so it must be sky*/
		&& 
		 (current_precip != NONE) && (current_color != NONE)){
		
		precip_type[i]	= current_precip;
		precip_color[i]	= current_color;
		precip_x[i]		= mouse_x;
		precip_y[i]		= mouse_y;

		/* The counter gets set to zero if the limit is reached, and 
		 * the amount drawn gets the counter unless the limit has been
		 * reached. */

		if (i < MAX_PRECIP_EVENTS &&
			(entry_num == i || entry_num == MAX_PRECIP_EVENTS)){
			i++;
			if (entry_num != MAX_PRECIP_EVENTS){
				entry_num = i;
			}
		}else{
			i = 0;
			entry_num = MAX_PRECIP_EVENTS;
		}
	
	}
      
      break;

    case GP142_PERIODIC:
				
		/* Changes the position of the sun over time. */
		if (precip_type [0] == NONE){	/* faster if clear weather */
			sun_x -= 2;
		}else{
			sun_x--;					/* slower if not */
		}

		/* Over time, the sun sets and the moon rises. */ 
		if (sun_x < -GP142_XMAX - 30){
			sun_x = - sun_x;

			if (sundown){
				sun_y--;
			}else{
				sun_y++;
			}
		}
				
			if (sun_y <= -(GP142_YMAX - 35)){
				sundown = FALSE;
			}else if (sun_y >= GP142_YMAX - 35){
				sundown = TRUE;
			}

		/* If the background is Seattle the moon
		 * never sets and the sun never rises. */
		
		if (place == SEATTLE){
			sun_y = -GP142_YMAX + 35;
		}
		
		/* Over time the precipitation falls. */
		for (n=0; n < entry_num; n++){

			switch (precip_type[n]) {
			case 1:
				precip_y[n] -= 8;
				break;
			case 2:
				precip_y[n] -= 3;
				break;
			case 3:
				precip_y[n] -= 12;
				if (precip_x[n] < GP142_XMAX){
					precip_x[n] ++;
				}else{
					precip_x[n] = -GP142_XMAX;
				}
				break;
			default:
				/* Not good if you get here. */
				GP142_printfXY (RED, 50, 50, 14, "Ohhhhh NOOOO!!!!");
				break;
			}

			/* Allows the precip. to fall further in Seattle. */
			if (place == SEATTLE){
				if (precip_y[n] <= -GP142_YMAX + 30){
					precip_y[n] = GP142_YMAX;
				}
			}else{
				if (precip_y[n] <= TOP_OF_DIRT - 30){
					precip_y[n] = GP142_YMAX;
				}
			}
		
			/* Gives the impression of the precip. wavering. */
			if (rand() % 3 == 0){
				precip_x[n]--;
			}else if (rand() % 2 == 0){
				precip_x[n]++;
			}
		}

		if (precip_type[0] != NONE){

		/* Over time the cloud moves. */
		cloud_x -= 5;
		if (cloud_x < (-GP142_XMAX-250)){
			cloud_x = GP142_XMAX + 1;		/* Resets the position. */
		}

		/* Over time the second cloud moves.
		 * Slower and in the opposite direction of first. */
		cloud2_x += 3;
		if (cloud2_x > (GP142_XMAX + 195)){
			cloud2_x = -GP142_XMAX - 195;	/* Resets the position. */
		}

		}

		/* Animates the lights on the Space Needle. */
		if (place==SEATTLE){
			if (lights==ON){
				lights=OFF;
			}else{
				lights=ON;
			}
		}

		break;

    default:

		break;
	
    }  /*end switch */

    /* Redraw everything */
    DrawLandscape(sun_x, sun_y, precip_type[0], cloud_x, cloud_y, 
		cloud2_x, cloud2_y, place, lights);
    DrawButtons(current_precip, current_color, place);
    DrawAllPrecipitation(precip_type, precip_x, precip_y,
		precip_color, entry_num, place);
  }  /* end event loop */


  /*
   * WRAP-UP
   */
  GP142_close();         /* clean up and close graphics window   */

  return 0;
}  /*end main */

/*********************************************************************

     FUNCTIONS

*********************************************************************/


/* Reinitialize so that ALL current precipitation is erased. */

void  ClearAllPrecipitation(int precip_type[], int * i, 
							int * entry_num, int * cloud_x, 
							int * cloud2_x){

  precip_type[0] = NONE;		/* Resets the first precip_type. */
  *i			= 0;				/* Resets the array counter. */
  *entry_num	= 0;
  *cloud_x		= GP142_XMAX + 1;	/* Resets the cloud's position. */
  *cloud2_x		= -GP142_XMAX - 195;	/* Resets the second cloud. */
}

void credits(int *main_quit){
	int quit = FALSE;
	int mouse_x, mouse_y;
	int event;
	char key_hit;
	int y_position = 3*(-GP142_YMAX/2);
	
	while (!quit) {  
	/*find out what has happened */
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
	
	switch (event) {
    case GP142_QUIT:
      quit = TRUE;		/* set flag to terminate loop */
	  *main_quit = TRUE;/* sets the flag to terminate main's loop */
      break;

    case GP142_KBD:
		/*Not needed for this function.*/
		break;
		
    case GP142_MOUSE:
		quit = TRUE;      
		break;

    case GP142_PERIODIC:
		y_position += 7;
		break;

    default:

      break;
	
    }  /*end switch */

    /* Redraw the buttons. */
    role_credits(y_position);

	if (y_position > GP142_YMAX *2){
		quit = TRUE;
		return;
	}
  }  
	return; 
}

void role_credits (int y_position){
	int font_size		= 25;
	int x_position		= -GP142_XMAX + 80;
	int line_change		= 50;

	/* Gives a new colored background. */
	GP142_rectangleXY(BLACK, -GP142_XMAX, -GP142_YMAX, GP142_XMAX, 
		GP142_YMAX, FILL);

	GP142_printfXY(BLUE, x_position, y_position, 3 * font_size,
		"Weather v2.06");
	GP142_printfXY(WHITE, x_position+135, y_position-line_change,
		font_size, "brought to you");
	GP142_printfXY(WHITE, x_position+200, y_position-(line_change*2),
		font_size, "by");
	GP142_printfXY(PURPLE, x_position+70, y_position-(line_change*4),
		2 * font_size, "Patrik Schneider");

}

#define RAINDROP_RADIUS 2

void DrawRainDrop (int x, int y, int color) { 

	GP142_circleXY(color, x, y, RAINDROP_RADIUS);
	GP142_triangleXY(color, (x-2), (y-1), x, (y+5), 
		(x+2), (y+1), FILL);

}

#define SNOWDROP_RADIUS 1

void DrawSnowDrop (int x, int y, int color) {

	GP142_circleXY(color, x, y, SNOWDROP_RADIUS);
	
	GP142_lineXY(color, x, (y+8), x, (y-8), 1);			/* Line #1*/
	GP142_lineXY(color, x, (y+6), (x+2), (y+8), 1);
	GP142_lineXY(color, x, (y+6), (x-2), (y+8), 1);
	GP142_lineXY(color, x, (y+4), (x+2), (y+6), 1);
	GP142_lineXY(color, x, (y+4), (x-2), (y+6), 1);
	GP142_lineXY(color, x, (y-6), (x+2), (y-8), 1);
	GP142_lineXY(color, x, (y-6), (x-2), (y-8), 1);
	GP142_lineXY(color, x, (y-4), (x+2), (y-6), 1);
	GP142_lineXY(color, x, (y-4), (x-2), (y-6), 1);

	GP142_lineXY(color, (x+8), y, (x-8), y, 1);			/* Line #2*/
	GP142_lineXY(color, (x+6), y, (x+8), (y+2), 1);
	GP142_lineXY(color, (x+6), y, (x+8), (y-2), 1);
	GP142_lineXY(color, (x+4), y, (x+6), (y+2), 1);
	GP142_lineXY(color, (x+4), y, (x+6), (y-2), 1);
	GP142_lineXY(color, (x-6), y, (x-8), (y+2), 1);
	GP142_lineXY(color, (x-6), y, (x-8), (y-2), 1);
	GP142_lineXY(color, (x-4), y, (x-6), (y+2), 1);
	GP142_lineXY(color, (x-4), y, (x-6), (y-2), 1);

	GP142_lineXY(color, (x+6), (y+6), (x-6), (y-6), 1);	/* Line #3*/
	GP142_lineXY(color, (x+6), (y+4), (x+4), (y+4), 1);
	GP142_lineXY(color, (x+4), (y+4), (x+4), (y+6), 1);
	GP142_lineXY(color, (x+4), (y+2), (x+2), (y+2), 1);
	GP142_lineXY(color, (x+2), (y+2), (x+2), (y+4), 1);
	GP142_lineXY(color, (x-6), (y-4), (x-4), (y-4), 1);
	GP142_lineXY(color, (x-4), (y-4), (x-4), (y-6), 1);
	GP142_lineXY(color, (x-4), (y-2), (x-2), (y-2), 1);
	GP142_lineXY(color, (x-2), (y-2), (x-2), (y-4), 1);

	GP142_lineXY(color, (x-6), (y+6), (x+6), (y-6), 1);	/* Line #4*/
	GP142_lineXY(color, (x-6), (y+4), (x-4), (y+4), 1);
	GP142_lineXY(color, (x-4), (y+4), (x-4), (y+6), 1);
	GP142_lineXY(color, (x-4), (y+2), (x-2), (y+2), 1);
	GP142_lineXY(color, (x-2), (y+2), (x-2), (y+4), 1);
	GP142_lineXY(color, (x+6), (y-4), (x+4), (y-4), 1);
	GP142_lineXY(color, (x+4), (y-4), (x+4), (y-6), 1);
	GP142_lineXY(color, (x+4), (y-2), (x+2), (y-2), 1);
	GP142_lineXY(color, (x+2), (y-2), (x+2), (y-4), 1);
}


void LighteningBolt (int x, int y, int color) {

	GP142_rectangleXY(color, x, y, (x+10), (y+10), FILL);
	GP142_triangleXY(color, (x-10), y, x, (y+30), (x+20), (y+30), 
		FILL);
	GP142_triangleXY(color, (x-10), y, x, y, (x+20), (y+30), FILL);
	GP142_triangleXY(color, (x+10), (y+10), (x+25), (y+10), (x-10), 
		(y-50), FILL);

}

void DrawAllPrecipitation(int precip_type[], int x[], int y[], 
						  int color[], int number_of_precip,
						  int place){

	int i;
	int drop_point; /* Lowers ground level, depending on city. */

	if (place == SEATTLE){
		drop_point = 120;
	}else{
		drop_point = 30;
	}

	for (i=0; i < number_of_precip; i++){

		if (y[i] >= TOP_OF_DIRT - drop_point) {
			switch (precip_type[i]) {
			case RAIN:
				DrawRainDrop (x[i], y[i], color[i]);
				break;
			case SNOW:
				DrawSnowDrop (x[i], y[i], color[i]);
				break;
			case LIGHTENING:
				LighteningBolt (x[i], y[i], color[i]);
				break;
			default:
				/*Bad news to ever get here.*/
				break;
			} /* end switch*/
		} /* end if */
	} /* end for */
} /* end function */



int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return BUTTON;
  else if (mouse_y <= TOP_OF_DIRT)
    return DIRT;
  else
    return NONE;

}


void DrawLandscape(int sun_x, int sun_y, int weather, int cloud_x, 
				   int cloud_y, int cloud2_x, int cloud2_y, int place, 
				   int lights)
{  

  /* Draw the sky first. */
  if (sun_y > 50){
	GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
  }else{
	GP142_rectangleXY(NAVY_BLUE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
  }
 
  /* Draw the sun or moon. */
  if (sun_y > 50){
	  GP142_triangleXY(ORANGE, (sun_x-24), sun_y, sun_x, (sun_y+24), 
		  (sun_x+24), sun_y, FILL);
	  GP142_triangleXY(ORANGE, (sun_x-24), sun_y, sun_x, (sun_y-24), 
		  (sun_x+24), sun_y, FILL);
	  GP142_rectangleXY(RED, (sun_x-17), (sun_y-17), (sun_x+17), 
		  (sun_y+17), FILL);
	  GP142_circleXY(YELLOW, sun_x, sun_y , 20);

	  if (weather==NONE){	/* Smiley face if good weather. */
		  GP142_circleXY(BLACK, sun_x, sun_y, 10);
		  GP142_circleXY(YELLOW, sun_x, sun_y, 8);
		  GP142_rectangleXY(YELLOW, (sun_x-10), sun_y, (sun_x+10), 
			  (sun_y+10), FILL);
	  }else{				/* Frown if not. */
		  GP142_lineXY(BLACK, (sun_x-8), (sun_y-7), (sun_x+8), 
			  (sun_y-7), 2);
	  }

	  GP142_circleXY(BLACK, (sun_x-5), (sun_y+5), 2);
	  GP142_circleXY(BLACK, (sun_x+5), (sun_y+5), 2);
  }else{
	  GP142_circleXY(CHALK, sun_x, -sun_y, 20);
	  
	  if (weather == NONE){	/* Smiley face if good weather. */
		  GP142_circleXY(BLACK, (sun_x-10), (-sun_y-5), 5);
		  GP142_circleXY(CHALK, (sun_x-10), (-sun_y-5), 3);
		  GP142_rectangleXY(CHALK, (sun_x-15), (-sun_y-5), 
			  (sun_x-5), -sun_y, FILL);
	  }else{				/* Frown if not. */
		  GP142_lineXY(BLACK, (sun_x-12), (-sun_y-10), (sun_x-8), 
			  (-sun_y-10), 2);
	  }
  
	  GP142_circleXY(BLACK, (sun_x-14), -sun_y, 1);
	  GP142_circleXY(NAVY_BLUE, (sun_x+10), -sun_y, 20);
	  GP142_triangleXY(CHALK, (sun_x-10), (-sun_y-2), (sun_x-10), 
		  (-sun_y-5), (sun_x-7), (-sun_y-5), FILL);
  }


  if (place == PATRIK_LAND){
	  DrawPatrikLand (sun_x, sun_y, cloud_x, cloud2_x, weather);
  }else{
	  DrawSeattle (lights);
  }

  /* Draw cloud */
  if (weather != 0){
  GP142_ovalXY(BLACK, (cloud_x+120), (cloud_y-80), (cloud_x+220), 
	  (cloud_y-20), FILL);
  GP142_ovalXY(MED_GRAY, (cloud_x+121), (cloud_y-79), (cloud_x+219), 
	  (cloud_y-21), FILL);

  GP142_ovalXY(BLACK, (cloud_x+90), (cloud_y-50), (cloud_x+200), 
	  (cloud_y+50), FILL);
  GP142_ovalXY(MED_GRAY, (cloud_x+91), (cloud_y-49), (cloud_x+199), 
	  (cloud_y+49), FILL);

  GP142_circleXY(BLACK, (cloud_x+220), (cloud_y-10), 40);
  GP142_circleXY(MED_GRAY, (cloud_x+220), (cloud_y-10), 39);

  GP142_circleXY(BLACK, (cloud_x+80), (cloud_y-50), 45);
  GP142_circleXY(MED_GRAY, (cloud_x+80), (cloud_y-50), 44);

  GP142_circleXY(BLACK, (cloud_x+20), (cloud_y-55), 30);
  GP142_circleXY(MED_GRAY, (cloud_x+20), (cloud_y-55), 29);
  
  GP142_circleXY(BLACK, cloud_x, cloud_y, 35);
  GP142_circleXY(MED_GRAY, cloud_x, cloud_y, 34);

  GP142_circleXY(BLACK, (cloud_x+60), cloud_y, 50);
  GP142_circleXY(MED_GRAY, (cloud_x+60), cloud_y, 49);

  GP142_rectangleXY(MED_GRAY, (cloud_x+10), (cloud_y-60), 
	  (cloud_x+120), (cloud_y+20), FILL);
  GP142_rectangleXY(MED_GRAY, (cloud_x+120), (cloud_y-56), 
	  (cloud_x+200), (cloud_y+15), FILL);
 
  /* Draw a second cloud. */
  GP142_ovalXY(BLACK, (cloud2_x+90), (cloud2_y-60), (cloud2_x+165), 
	  (cloud2_y-15), FILL);
  GP142_ovalXY(MED_GRAY, (cloud2_x+91), (cloud2_y-59), (cloud2_x+164), 
	  (cloud2_y-16), FILL);

  GP142_ovalXY(BLACK, (cloud2_x+68), (cloud2_y-38), (cloud2_x+150), 
	  (cloud2_y+38), FILL);
  GP142_ovalXY(MED_GRAY, (cloud2_x+69), (cloud2_y-37), (cloud2_x+149), 
	  (cloud2_y+37), FILL);

  GP142_circleXY(BLACK, (cloud2_x+165), (cloud2_y-8), 30);
  GP142_circleXY(MED_GRAY, (cloud2_x+165), (cloud2_y-8), 29);

  GP142_circleXY(BLACK, (cloud2_x+60), (cloud2_y-38), 34);
  GP142_circleXY(MED_GRAY, (cloud2_x+60), (cloud2_y-38), 33);

  GP142_circleXY(BLACK, (cloud2_x+15), (cloud2_y-41), 23);
  GP142_circleXY(MED_GRAY, (cloud2_x+15), (cloud2_y-41), 22);
  
  GP142_circleXY(BLACK, cloud2_x, cloud2_y, 26);
  GP142_circleXY(MED_GRAY, cloud2_x, cloud2_y, 25);

  GP142_circleXY(BLACK, (cloud2_x+45), cloud2_y, 38);
  GP142_circleXY(MED_GRAY, (cloud2_x+45), cloud2_y, 37);

  GP142_rectangleXY(MED_GRAY, (cloud2_x+5), (cloud2_y-45), 
	  (cloud2_x+90), (cloud2_y+15), FILL);
  GP142_rectangleXY(MED_GRAY, (cloud2_x+90), (cloud2_y-43), 
	  (cloud2_x+150), (cloud2_y+11), FILL);
  }

} /*end DrawLandscape */


/* Figure out which button was clicked */
void handle_button(int x, int y, int *current_precip, 
				   int *current_color, int *clear_weather,
				   int *new_background){

  int max_speed = 80;
  int buttonNum = 0;

  *clear_weather = FALSE; /* Assume we don't replant */

  /* If we're outside of this area, we could not have clicked on
   * a button.
   */
  if (x > -GP142_XMAX + BUTTON_WIDTH)  return;

  /* We know the mouse clicked in the column of buttons. */
  buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;
    break;
  case 1:
    *current_precip = SNOW;
    break;
  case 2:
	*current_precip = LIGHTENING;
	break;

  case 3:
    *current_color = WHITE;
    break;
  case 4:
    *current_color = BLUE;
    break;
  case 5:
	*current_color = YELLOW;
	break;
 
  case 6:
    *clear_weather = TRUE;
    break; /* Signal to clear up the weather */

  case 7:
	  *new_background = TRUE;
	  break; /* User wants to pick a new background. */

  default:
		/*Bad news if this is ever reached! */
		GP142_printfXY (RED, 50, 50, 14, "BAAADD NEWS!");
    break;
  }

}


/* Draws the buttons */
void DrawButtons(int current_precip, int current_color, int place)
{
  int i, text_offset = -GP142_XMAX + 15, font_size = 12;

  /* draw rectangles for each button */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(BLACK,
		      -GP142_XMAX + 4,
		      GP142_YMAX - i * BUTTON_HEIGHT - 2,
		      -GP142_XMAX + BUTTON_WIDTH,
		      GP142_YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* display button text
   * "selected" buttons are highlighted (i.e., have a different color)
   * This whole mess could be cleaned and put into a function
   * if we could use strings. */
  i = GP142_YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i-5, font_size+5,
		"Rain");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Rain");	

  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i-5, font_size+5,
		"Snow");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Snow");

  i -= BUTTON_HEIGHT;
  if (current_precip == LIGHTENING)
    GP142_printfXY(SELECTED_COLOR, text_offset, i-5, font_size+5, 
	"Lightening");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Lightening");

  
  /* Buttons for Colors */
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i-5, font_size+5, 
	"White");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "White");

  i -= BUTTON_HEIGHT;
  if (current_color == BLUE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i-5, font_size+5,
		"Blue");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Blue");

  i -= BUTTON_HEIGHT;
  if (current_color == YELLOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i-5, font_size+5, 
	"Yellow");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Yellow");

  /* Neither of these buttons are ever "selected" */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, font_size, "Cease!");

  i -= BUTTON_HEIGHT;
  if (place == SEATTLE){
	  GP142_printfXY(BLACK, text_offset, i, font_size, 
		  "Patrik Land");
  }else{
	  GP142_printfXY(BLACK, text_offset, i, font_size, 
		  "Seattle");
  }

}


void BadNewsMessage (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}

void WhichCity(int *place, int *main_quit){
	int quit = FALSE;
	int mouse_x, mouse_y;
	int mouse_click;
	int event;
	char key_hit;

	while (!quit) {  

	/*find out what has happened */
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
	
	switch (event) {
    case GP142_QUIT:
      quit = TRUE;		/* set flag to terminate loop */
	  *main_quit = TRUE;		/* sets the flag to terminate main's loop */
      break;

    case GP142_KBD:
		/*Not needed for this function.*/
		break;
		
    case GP142_MOUSE:

		mouse_click = ClassifyWhichButton(mouse_x, mouse_y);
		if (mouse_click != BACKGROUND){
			*place	= mouse_click;
			quit	= TRUE;
		}
		      
      break;

    case GP142_PERIODIC:
    break;

    default:

      break;
	
    }  /*end switch */

    /* Redraw the buttons. */
    DrawFirstButtons();
  }  
	return; 
}


/* Figure out which button was clicked */
int ClassifyWhichButton(int x, int y){

	if ((x > (-BUTTON_WIDTH *2) && x < (-BUTTON_WIDTH)) &&
		(y > 0 && y < BUTTON_HEIGHT)){
		return (PATRIK_LAND);
	}else if ((x < (BUTTON_WIDTH *2) && x > (BUTTON_WIDTH)) &&
		(y > 0 && y < BUTTON_HEIGHT)){
		return (SEATTLE);
	}else{
		return (BACKGROUND);
	}
}

/* Draws the buttons */
void DrawFirstButtons(void)
{
  int font_size = 20;

  /* Draw Background. */
  GP142_rectangleXY(BLACK, -GP142_XMAX, -GP142_YMAX, 
	  GP142_XMAX, GP142_YMAX, FILL);

  /* Poses the Question: */
  GP142_printfXY(CYAN, -285, (BUTTON_HEIGHT * 2),
	  (3 * font_size)/2,
	  "Which city's weather would you like to control?");
  
  /* draw rectangles for each button */
  GP142_rectangleXY(CYAN, (-BUTTON_WIDTH * 2), 0, -BUTTON_WIDTH,
	  BUTTON_HEIGHT, FILL);
  GP142_rectangleXY(CYAN, BUTTON_WIDTH, 0, (BUTTON_WIDTH * 2),
	  BUTTON_HEIGHT, FILL);

  /* display button text */
  GP142_printfXY(BLACK, (-BUTTON_WIDTH * 2) + 10, 
	  (BUTTON_HEIGHT-30), font_size, "Patrik Land");
  GP142_printfXY(BLACK, (BUTTON_WIDTH + 25), 
	  (BUTTON_HEIGHT-30), font_size, "Seattle");
}

void DrawPatrikLand (int sun_x, int sun_y, int cloud_x, int cloud2_x, 
					 int weather){

	int text_offset = -GP142_XMAX + 15, font_size = 12;
	
	/* Condition for the shadows of the sign. */
	int sun_behind_cloud = FALSE; 

  /* Draw the dirt */
  /* The dirt is a % of the height of the screen */
  GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_DIRT, FILL);
  GP142_printfXY (BLACK, text_offset, TOP_OF_DIRT-20, font_size,
	  "Click a weather type and a color, then click on the picture.");

  
  /*Draw the mountains */
  GP142_triangleXY(LT_GRAY,
		   -GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   0, (4 * GP142_YMAX)/5 ,
		   FILL);

  GP142_triangleXY(OLIVE,
		   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
		   (GP142_XMAX)/3  , TOP_OF_DIRT,
		   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		   FILL);

  GP142_triangleXY(FOREST_GREEN,
		   -GP142_XMAX / 3 , TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, (2 * GP142_YMAX)/3 ,
		   FILL);

  /* Draw the road. */
  GP142_triangleXY(BLACK, -GP142_XMAX, -GP142_YMAX, GP142_XMAX / 3 , 
	  TOP_OF_DIRT, 0, -GP142_YMAX, 0);

  /* Coordinates obtained by finding the line y=(3/5)x-160 and
   * calculating all the (int, int) points. */
  GP142_lineXY(YELLOW, -150, -250, -80, -208, 5);
  GP142_lineXY(YELLOW, -50, -190, -5, -163, 4);
  GP142_lineXY(YELLOW, 20, -149, 40, -136, 3);
  GP142_lineXY(YELLOW, 60, -124, 70, -118, 2);
  GP142_lineXY(YELLOW, 80, -112, 90, -106, 1);
  GP142_lineXY(YELLOW, 95, -103, 100, -100, 0);

  /* Finds whether or not the sun is behind either cloud. */
  if (weather != NONE){
	  if ((sun_x < (cloud_x-35) && sun_x < (cloud_x+260)) &&
		  (sun_x > (cloud2_x-26) && sun_x > (cloud2_x+195))){
		  sun_behind_cloud = FALSE;
	  }else if ((sun_x < (cloud_x-35) && sun_x < (cloud_x+260)) &&
		  (sun_x < (cloud2_x-26) && sun_x < (cloud2_x+195))){
		  sun_behind_cloud = FALSE;
	  }else if ((sun_x > (cloud_x-35) && sun_x > (cloud_x+260)) &&
		  (sun_x < (cloud2_x-26) && sun_x < (cloud2_x+195))){
		  sun_behind_cloud = FALSE;
	  }else if ((sun_x > (cloud_x-35) && sun_x > (cloud_x+260)) &&
		  (sun_x > (cloud2_x-26) && sun_x > (cloud2_x+195))){
		  sun_behind_cloud = FALSE;
	  }else{
		  sun_behind_cloud = TRUE;
	  }
  }

  /* Draw road sign. */
  /* Animated shadows of the sign. */
  if (sun_y > 75 && !sun_behind_cloud){
	  GP142_lineXY(MED_GRAY, 45, -225, (-sun_x+150), -275, 6);
	  GP142_lineXY(MED_GRAY, 105, -225, (-sun_x+225), -275, 6);
  }			
  
  GP142_rectangleXY(LT_GRAY, 40, -225, 50, -200, 0);
  GP142_rectangleXY(LT_GRAY, 100, -225, 110, -200, 0);
  GP142_rectangleXY(SEA_GREEN, 30, -200, 120, -150, 0);
  GP142_rectangleXY(WHITE, 35, -195, 115, -155, 2);
  GP142_printfXY(BLACK, 50, -170, 10, "WELCOME");
  GP142_printfXY(BLACK, 70, -182, 10, "to");
  GP142_printfXY(BLACK, 45, -195, 13, "Patrik Land");
}

void DrawSeattle(int lights){  

	int text_offset = -GP142_XMAX + 15, font_size = 12;

	/* Draw a box behind the buttons to make them easier to see. */
  GP142_rectangleXY(CHALK, (-GP142_XMAX + 4), (GP142_YMAX - 
	  (NUM_BUTTONS * BUTTON_HEIGHT)), (-GP142_XMAX + BUTTON_WIDTH),
	  GP142_YMAX, FILL);

   /* Draw the dirt */
  /* The dirt is a % of the height of the screen */
  GP142_rectangleXY(BLACK, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, -76, FILL);
  GP142_printfXY (CHALK, text_offset, -GP142_YMAX+15, font_size,
	  "Click a weather type and a color, then click on the picture.");
  
  /*Draw the mountains */
  GP142_triangleXY(BLACK, -426, -38, -250, 46, 13, -38, FILL);
  GP142_triangleXY(MED_GRAY, -425, -38, -250, 45, 12, -38, FILL);
  GP142_triangleXY(BLACK, -174, -37, -24, 1, 126, -37, FILL);		  
  GP142_triangleXY(MED_GRAY, -175, -38, -25, 0, 125, -38, FILL);
  GP142_rectangleXY(MED_GRAY, -300, -76, 300, -38, FILL);
  GP142_lineXY(BLACK, 125, -38, 300, -38, 1);

  /* Draw buildings. */
  GP142_rectangleXY(BLACK, -276, -180, -169, -39, FILL);	/* # 1 */
  GP142_rectangleXY(DUSTY_PLUM, -275, -180, -170, -40, FILL);

  GP142_rectangleXY(BLACK, -300, -214, -224, -75, FILL);	/* # 2 */
  GP142_rectangleXY(PEACH, -300, -214, -225, -76, FILL);

  GP142_rectangleXY(BROWN, -155, -180, 30, -90, FILL);		/* # 3 */

  GP142_rectangleXY(BLACK, -216, -200, -127, -69, FILL);	/* # 4 */
  GP142_rectangleXY(OLIVE, -215, -200, -128, -70, FILL);
  GP142_rectangleXY(BLACK, -201, -70, -149, -59, FILL);
  GP142_rectangleXY(OLIVE, -200, -70, -150, -60, FILL);
  
  GP142_rectangleXY(BLACK, -151, -207, -99, -81, FILL);		/* # 5 */
  GP142_rectangleXY(ICE_BLUE, -150, -207, -100, -82, FILL);
  GP142_rectangleXY(BLACK, -136, -82, -109, -76, FILL);
  GP142_rectangleXY(ICE_BLUE, -135, -82, -110, -77, FILL);

  GP142_rectangleXY(BLACK, -81, -220, 1, -156, FILL);		/* # 6 */
  GP142_rectangleXY(GOLD, -80, -220, 0, -157, FILL);
  GP142_rectangleXY(BLACK, -76, -157, 1, -69, FILL);
  GP142_rectangleXY(GOLD, -75, -157, 0, -70, FILL);
  
  GP142_rectangleXY(BLACK, 24, -225, 101, -37, FILL);		/* # 7 */
  GP142_rectangleXY(CYAN, 25, -225, 100, -38, FILL);
  
  GP142_rectangleXY(BLACK, 99, -207, 176, -69, FILL);		/* # 8 */
  GP142_rectangleXY(DUSTY_PLUM, 100, -207, 175, -70, FILL);
  
  GP142_rectangleXY(BLACK, 169, -125, 216, -19, FILL);		/* # 9 */
  GP142_rectangleXY(ICE_BLUE, 170, -125, 215, -20, FILL);

  GP142_rectangleXY(BLACK, 199, -207, 301, -69, FILL);		/* #10 */
  GP142_rectangleXY(GOLD, 200, -207, 300, -70, FILL);
  GP142_rectangleXY(BLACK, 214, -70, 301, 46, FILL);
  GP142_rectangleXY(GOLD, 215, -70, 300, 45, FILL);
  GP142_triangleXY(BLACK, 229, 45, 291, 45, 260, 71, FILL);
  GP142_triangleXY(GOLD, 230, 45, 290, 45, 260, 70, FILL);

  GP142_rectangleXY(BLACK, 162, -207, 226, -119, FILL);		/* #11 */
  GP142_rectangleXY(FOREST_GREEN, 163, -207, 225, -120, FILL);

  GP142_rectangleXY(BLACK, 234, -207, 301, -71, FILL);		/* #12 */
  GP142_rectangleXY(BROWN, 235, -207, 300, -72, FILL);
  GP142_triangleXY(BLACK, 234, -72, 326, -72, 325, -34 , FILL);
  GP142_triangleXY(BROWN, 235, -72, 325, -72, 325, -35 , FILL);

  /* Draw Space Needle. */
  GP142_rectangleXY(BLACK, 74, -230, 101, 113, FILL);
  GP142_rectangleXY(MED_GRAY, 75, -230, 100, 113, FILL);

  GP142_rectangleXY(MED_GRAY, 26, -189, 136, -167, FILL);
  GP142_rectangleXY(LT_GRAY, 27, -188, 135, -168 , FILL);
  
  GP142_rectangleXY(BLACK, 26, -178, 135, -173, FILL);
  
  GP142_lineXY(MED_GRAY, 25, -240, 75, 40, 12);
  GP142_lineXY(LT_GRAY, 25, -240, 75, 40, 10);

  GP142_lineXY(MED_GRAY, 50, -250, 75, 40, 12);
  GP142_lineXY(LT_GRAY, 50, -250, 75, 40, 10);

  GP142_lineXY(MED_GRAY, 150, -240, 85, 25, 12);
  GP142_lineXY(LT_GRAY, 150, -240, 85, 25, 10);

  GP142_lineXY(LT_GRAY, 85, 25, 38, 113, 8);

  GP142_lineXY(LT_GRAY, 85, 25, 137, 113, 8);

  GP142_triangleXY(MED_GRAY, -11, 112, 186, 112, 88, 164, FILL);
  GP142_triangleXY(LT_GRAY, -10, 113, 185, 113, 88, 163, FILL);
  
  GP142_triangleXY(MED_GRAY, 9, 139, 166, 139, 88, 164, FILL);
  GP142_triangleXY(LT_GRAY, 10, 140, 165, 140, 88, 163, FILL);

  GP142_lineXY(MED_GRAY, 88, 175, 88, 200, 6);
  GP142_lineXY(LT_GRAY, 88, 175, 88, 200, 5);

  GP142_triangleXY(MED_GRAY, 39, 151, 136, 151, 88, 176, FILL);
  GP142_triangleXY(LT_GRAY, 40, 152, 135, 152, 88, 175, FILL);

  GP142_rectangleXY(MED_GRAY, -1, 134, 176, 141, FILL);
  GP142_rectangleXY(LT_GRAY, 0, 135, 175, 140, FILL);

  GP142_rectangleXY(MED_GRAY, -26, 124, 201, 131, FILL);
  GP142_rectangleXY(LT_GRAY, -25, 125, 200, 130, FILL);

  GP142_rectangleXY(MED_GRAY, -13, 129, 188, 136, FILL);
  GP142_rectangleXY(LT_GRAY, -12, 130, 187, 135, FILL);

  GP142_lineXY(YELLOW, -10, 132, 185, 132, 3);

  if (lights==ON){
	  GP142_rectangleXY(LT_GRAY, -12, 130, 22, 135, FILL);
	  GP142_rectangleXY(LT_GRAY, 55, 130, 88, 135, FILL);
	  GP142_rectangleXY(LT_GRAY, 121, 130, 154, 135, FILL);
	  GP142_circleXY(RED, 88, 203, 5);
  }else{
	  GP142_rectangleXY(LT_GRAY, 22, 130, 55, 135, FILL);
	  GP142_rectangleXY(LT_GRAY, 88, 130, 121, 135, FILL);
	  GP142_rectangleXY(LT_GRAY, 154, 130, 187, 135, FILL);
	  GP142_circleXY(MED_GRAY, 88, 203, 3);
  }
} /*end DrawLandscape */
